// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from automotive_platform_msgs:msg/UserInputMedia.idl
// generated code does not contain a copyright notice
#include "automotive_platform_msgs/msg/detail/user_input_media__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
automotive_platform_msgs__msg__UserInputMedia__init(automotive_platform_msgs__msg__UserInputMedia * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    automotive_platform_msgs__msg__UserInputMedia__fini(msg);
    return false;
  }
  // btn_vol_up
  // btn_vol_down
  // btn_mute
  // btn_next
  // btn_prev
  // btn_next_hang_up
  // btn_prev_answer
  // btn_hang_up
  // btn_answer
  // btn_play
  // btn_pause
  // btn_play_pause
  // btn_mode
  return true;
}

void
automotive_platform_msgs__msg__UserInputMedia__fini(automotive_platform_msgs__msg__UserInputMedia * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // btn_vol_up
  // btn_vol_down
  // btn_mute
  // btn_next
  // btn_prev
  // btn_next_hang_up
  // btn_prev_answer
  // btn_hang_up
  // btn_answer
  // btn_play
  // btn_pause
  // btn_play_pause
  // btn_mode
}

bool
automotive_platform_msgs__msg__UserInputMedia__are_equal(const automotive_platform_msgs__msg__UserInputMedia * lhs, const automotive_platform_msgs__msg__UserInputMedia * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // btn_vol_up
  if (lhs->btn_vol_up != rhs->btn_vol_up) {
    return false;
  }
  // btn_vol_down
  if (lhs->btn_vol_down != rhs->btn_vol_down) {
    return false;
  }
  // btn_mute
  if (lhs->btn_mute != rhs->btn_mute) {
    return false;
  }
  // btn_next
  if (lhs->btn_next != rhs->btn_next) {
    return false;
  }
  // btn_prev
  if (lhs->btn_prev != rhs->btn_prev) {
    return false;
  }
  // btn_next_hang_up
  if (lhs->btn_next_hang_up != rhs->btn_next_hang_up) {
    return false;
  }
  // btn_prev_answer
  if (lhs->btn_prev_answer != rhs->btn_prev_answer) {
    return false;
  }
  // btn_hang_up
  if (lhs->btn_hang_up != rhs->btn_hang_up) {
    return false;
  }
  // btn_answer
  if (lhs->btn_answer != rhs->btn_answer) {
    return false;
  }
  // btn_play
  if (lhs->btn_play != rhs->btn_play) {
    return false;
  }
  // btn_pause
  if (lhs->btn_pause != rhs->btn_pause) {
    return false;
  }
  // btn_play_pause
  if (lhs->btn_play_pause != rhs->btn_play_pause) {
    return false;
  }
  // btn_mode
  if (lhs->btn_mode != rhs->btn_mode) {
    return false;
  }
  return true;
}

bool
automotive_platform_msgs__msg__UserInputMedia__copy(
  const automotive_platform_msgs__msg__UserInputMedia * input,
  automotive_platform_msgs__msg__UserInputMedia * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // btn_vol_up
  output->btn_vol_up = input->btn_vol_up;
  // btn_vol_down
  output->btn_vol_down = input->btn_vol_down;
  // btn_mute
  output->btn_mute = input->btn_mute;
  // btn_next
  output->btn_next = input->btn_next;
  // btn_prev
  output->btn_prev = input->btn_prev;
  // btn_next_hang_up
  output->btn_next_hang_up = input->btn_next_hang_up;
  // btn_prev_answer
  output->btn_prev_answer = input->btn_prev_answer;
  // btn_hang_up
  output->btn_hang_up = input->btn_hang_up;
  // btn_answer
  output->btn_answer = input->btn_answer;
  // btn_play
  output->btn_play = input->btn_play;
  // btn_pause
  output->btn_pause = input->btn_pause;
  // btn_play_pause
  output->btn_play_pause = input->btn_play_pause;
  // btn_mode
  output->btn_mode = input->btn_mode;
  return true;
}

automotive_platform_msgs__msg__UserInputMedia *
automotive_platform_msgs__msg__UserInputMedia__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_platform_msgs__msg__UserInputMedia * msg = (automotive_platform_msgs__msg__UserInputMedia *)allocator.allocate(sizeof(automotive_platform_msgs__msg__UserInputMedia), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(automotive_platform_msgs__msg__UserInputMedia));
  bool success = automotive_platform_msgs__msg__UserInputMedia__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
automotive_platform_msgs__msg__UserInputMedia__destroy(automotive_platform_msgs__msg__UserInputMedia * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    automotive_platform_msgs__msg__UserInputMedia__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
automotive_platform_msgs__msg__UserInputMedia__Sequence__init(automotive_platform_msgs__msg__UserInputMedia__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_platform_msgs__msg__UserInputMedia * data = NULL;

  if (size) {
    data = (automotive_platform_msgs__msg__UserInputMedia *)allocator.zero_allocate(size, sizeof(automotive_platform_msgs__msg__UserInputMedia), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = automotive_platform_msgs__msg__UserInputMedia__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        automotive_platform_msgs__msg__UserInputMedia__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
automotive_platform_msgs__msg__UserInputMedia__Sequence__fini(automotive_platform_msgs__msg__UserInputMedia__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      automotive_platform_msgs__msg__UserInputMedia__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

automotive_platform_msgs__msg__UserInputMedia__Sequence *
automotive_platform_msgs__msg__UserInputMedia__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_platform_msgs__msg__UserInputMedia__Sequence * array = (automotive_platform_msgs__msg__UserInputMedia__Sequence *)allocator.allocate(sizeof(automotive_platform_msgs__msg__UserInputMedia__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = automotive_platform_msgs__msg__UserInputMedia__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
automotive_platform_msgs__msg__UserInputMedia__Sequence__destroy(automotive_platform_msgs__msg__UserInputMedia__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    automotive_platform_msgs__msg__UserInputMedia__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
automotive_platform_msgs__msg__UserInputMedia__Sequence__are_equal(const automotive_platform_msgs__msg__UserInputMedia__Sequence * lhs, const automotive_platform_msgs__msg__UserInputMedia__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!automotive_platform_msgs__msg__UserInputMedia__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
automotive_platform_msgs__msg__UserInputMedia__Sequence__copy(
  const automotive_platform_msgs__msg__UserInputMedia__Sequence * input,
  automotive_platform_msgs__msg__UserInputMedia__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(automotive_platform_msgs__msg__UserInputMedia);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    automotive_platform_msgs__msg__UserInputMedia * data =
      (automotive_platform_msgs__msg__UserInputMedia *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!automotive_platform_msgs__msg__UserInputMedia__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          automotive_platform_msgs__msg__UserInputMedia__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!automotive_platform_msgs__msg__UserInputMedia__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
