// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from automotive_platform_msgs:msg/SteerWheel.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__STEER_WHEEL__STRUCT_H_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__STEER_WHEEL__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/SteerWheel in the package automotive_platform_msgs.
/**
  * Steering Wheel Control Message with Mode
  * Contains steering wheel command and desired autonomy active mode flag
 */
typedef struct automotive_platform_msgs__msg__SteerWheel
{
  std_msgs__msg__Header header;
  /// Is 1 if autonomy mode should be active
  uint16_t mode;
  /// Desired steering wheel angle (rad)
  float angle;
  /// Desired steering wheel angle max velocity (rad/sec)
  float angle_velocity;
} automotive_platform_msgs__msg__SteerWheel;

// Struct for a sequence of automotive_platform_msgs__msg__SteerWheel.
typedef struct automotive_platform_msgs__msg__SteerWheel__Sequence
{
  automotive_platform_msgs__msg__SteerWheel * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} automotive_platform_msgs__msg__SteerWheel__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__STEER_WHEEL__STRUCT_H_
